//+------------------------------------------------------------------+
//|                                                       RSS_v1.mq4 |
//|                                                                  |
//| Relative Strenght Spread                                         |
//| Algorithm from TASC Octuber 2006 by Ian Copsey                   |
//|                                                        Linuxser  |
//|                                       http://www.linuxser.com.ar |
//|                                         http://www.forex-tsd.com |
//|                                                    November 2008 |
//+------------------------------------------------------------------+
#property copyright "Linuxser under GNU V2 license"
#property link      "www.linuxser.com.ar and www.forex-tsd.com"


//
//
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Red

#property indicator_minimum -5
#property indicator_maximum 105
#property indicator_level1 20
#property indicator_level2 80
//
//
/*************************************************************************
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
**************************************************************************/

extern int EMA1=10;
extern int EMA2=40;
extern int Lenght=5;
extern int PriceMode=0;
extern int SmoothMode=1;
//
//
double     RSSBuffer3[];
double     RSSBuffer2[];
double     RSSBuffer1[];
string fast_name;


//
//
//
int init()
  {
//
//
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,Lenght);
   IndicatorDigits(Digits+1);
//
//
   IndicatorBuffers(3);
   SetIndexBuffer(0,RSSBuffer3);
   SetIndexBuffer(1,RSSBuffer2);
   SetIndexBuffer(2,RSSBuffer1);
//
//   
   SetIndexLabel(0,"RSS"); 
   SetIndexLabel(1,NULL); 
   SetIndexLabel(2,NULL); 
   
   switch(PriceMode)
   {
   case 1 : fast_name="Open"; break;
   case 2 : fast_name="High"; break;
   case 3 : fast_name="Low"; break;
   case 4 : fast_name="Median"; break;
   case 5 : fast_name="Typical"; break;
   case 6 : fast_name="Weighted"; break;
   default: PriceMode=0; fast_name="Close";
   }      

   IndicatorShortName("RSS("+EMA1+","+EMA2+",["+Lenght+",on "+fast_name+"])");
//
//
   return(0);
  }
//  
//+---------------------------+
//| Relative Strenght Spread  |
//+---------------------------+
//
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//
//
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//
//
   for(int i=0; i<limit; i++)
      RSSBuffer1[i]=iMA(NULL,0,EMA1,0,MODE_EMA,PriceMode,i)-iMA(NULL,0,EMA2,0,MODE_EMA,PriceMode,i);
//---- 
   for(i=0; i<limit; i++)
      RSSBuffer2[i]=iRSIOnArray(RSSBuffer1,Bars,Lenght,i);      
//
// 
   for(i=0; i<limit; i++)
      RSSBuffer3[i]=iMAOnArray(RSSBuffer2,Bars,Lenght,0,MODE_EMA,i);
//
//
   return(0);
  }
//

